%global _find_debuginfo_dwz_opts %{nil}
%global _dwz_low_mem_die_limit 0

%global gohomepath github.com/containernetworking
%global goipath %{gohomepath}/plugins

Summary:       Libraries for writing CNI plugin
Name:          containernetworking-plugins
Version:       1.3.0
Release:       3%{?dist}
License:       ASL 2.0 and BSD and MIT
URL:           https://%{goipath}
Source0:       %{url}/archive/v%{version}.tar.gz

BuildRequires: golang systemd-devel go-rpm-macros go-md2man
Requires:      systemd

Provides:      containernetworking-cni = %{version}-%{release}
Provides:      kubernetes-cni
Provides:      container-network-stack = 1

%description
The CNI (Container Network Interface) project consists of a specification and libraries for
writing plugins to configure network interfaces in Linux containers, along with a number of
supported plugins. CNI concerns itself only with network connectivity of containers and
removing allocated resources when the container is deleted.

%prep
%autosetup -p1 -n plugins-%{version}
rm -rf plugins/main/windows
sed -i 's/\/opt\/cni\/bin/\%{_prefix}\/libexec\/cni/' plugins/ipam/dhcp/systemd/cni-dhcp.service

%build
export GOPATH=$PWD/.gopath
mkdir -p $GOPATH/src/%{gohomepath}
ln -sfn $PWD $GOPATH/src/%{goipath}

PLUGINS="plugins/meta/* plugins/main/* plugins/ipam/* plugins/sample"
for d in $PLUGINS; do
    %gobuild -o ${PWD}/bin/$(basename "$d") %{goipath}/$d
done

%install
install -Dpm 0755 bin/* -t %{buildroot}/%{_libexecdir}/cni
install -Dp plugins/ipam/dhcp/systemd/cni-dhcp.service \
            plugins/ipam/dhcp/systemd/cni-dhcp.socket -t %{buildroot}%{_unitdir}

%post
%systemd_post cni-dhcp.service

%preun
%systemd_preun cni-dhcp.service

%postun
%systemd_postun cni-dhcp.service

%files
%license LICENSE
%doc *.md
%dir %{_libexecdir}/cni
%{_libexecdir}/cni/*
%{_unitdir}/cni-dhcp.service
%{_unitdir}/cni-dhcp.socket

%changelog
* Fri Dec 29 2023 jackeyji <jackeyji@tencent.com> - 1.3.0-3
- Rebuilt for golang CVE-2023-39318 and CVE-2023-39319

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.0-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 03 2023 kianli <kianli@tencent.com> - 1.3.0-1
- Upgrade to 1.3.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.1-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.1-3
- Rebuilt for OpenCloudOS Stream 23

* Mon Dec 19 2022 Shuo Wang <abushwang@tencent.com> - 1.1.1-2
- fix service remain after uninstall

* Mon Dec 19 2022 Shuo Wang <abushwang@tencent.com> - 1.1.1-1
- initial build
